/*
Definition af arbejdsfunktionen.
*/
typedef void (*work_f)(void *);

/*
ben definition af en arbejdsk instans. Denne kan
ndress efter behov, slnge det ikke ndrer p nedenstende
funktioners grnseflade.
*/
typedef struct wqueue wqueue_t;

/*
Indstter et stykke arbejde i form af en funktion 'func' og det
data 'data' den skal kaldes med. Prioriteten 'pri' angiver
arbejdets prioritet. 'wq' peger p en instans af arbejdsken.

Lykkedes indsttelsen skal funktionen returnerer '0'. Ved fejl '-1'.
*/
int wqueue_insert(wqueue_t *wq, unsigned int pri, work_f func, void *data);

/*
Udfrer et stykke arbejde fra ken.

Hvis ken er tom returneres '0', ellers '1'.
*/
int wqueue_run(wqueue_t *wq);
