#include "wqueue.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>




/* til at teste med */
void printq(wqueue_t *wq)
{
  printf("///////////START/////////////////\n");
  wqueue_t *temp_q = wq;
  if(temp_q->next == NULL && temp_q->data == NULL)
    printf("Ken er tom\n");

  while(temp_q->next != NULL)
    {
      printf("Data i ken er: %d\n", ( *(int*) temp_q->data));
      temp_q = temp_q->next;
    }

  if(temp_q->next == NULL && temp_q->data != NULL) 
    printf("Data i ken er: %d\n", ( *(int*) temp_q->data));

  printf("////////////STOP////////////////\n");
}


/* En funktion der udskriver det medleverede data */
void write(void *data)
{
  /* vi antager at det data der skal udskrives er en streng */
  char streng[10];
  memcpy(streng, data, 10);
  printf("Data er: %s\n", streng);
}


/* en funktion der summerer to tal og konverterer resultatet til en streng og udskriver
det ved at indstte en ny arbejdsopgave, der anvender den ovenstaende funktion. */
void mult(void *data)
{
  int i;
  int rand_int = rand()%10;

  int_mult *temp;
  temp = (int_mult*) data;
  i = temp->m+temp->n;

  /* konvertering af int til streng */
  char temp_str[10];
  char *streng = malloc(sizeof(temp_str));
  sprintf(streng,"%d", i);

  /* instning af nyt arbejde i ken */
  wqueue_insert(head, rand_int, write, streng);
  printf("Mult har indsat %d med pri %d\n", i, rand_int);
}


int main()
{
  /* initialisering af k: */
  head = init_queue();
  
  /* initialisering af datastrukturer til at holde de to tal der skal ganges med hinanden */
  int_mult *mult1 = malloc(sizeof(int_mult));
  int_mult *mult2 = malloc(sizeof(int_mult));
  int_mult *mult3 = malloc(sizeof(int_mult));
  int_mult *mult4 = malloc(sizeof(int_mult));


  char i[10] = "3";
  char j[10] = "1";
  char k[10] = "0";
  char l[10] = "2";
  
  mult1->m = 2;
  mult1->n = 3;

  mult2->m = 5;
  mult2->n = 6;
  
  mult3->m = 4;
  mult3->n = 8;
  
  mult4->m = 7;
  mult4->n = 6;

  
  wqueue_insert(head, 1, write, &i);
  wqueue_insert(head, 2, write, &j);
  wqueue_insert(head, 3, write, &k);
  wqueue_insert(head, 2, write, &l);

  wqueue_insert(head, 1, mult, mult1);
  wqueue_insert(head, 2, mult, mult2);
  wqueue_insert(head, 3, mult, mult3);
  wqueue_insert(head, 4, mult, mult4);

  while(wqueue_run(head));

  printf("Ken er tom\n");

  return 0;
}
